Index: /trunk/src/sys/arch/mips/mips/mips_fpu.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips_fpu.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips_fpu.c	(revision 152)
@@ -30,5 +30,7 @@
 #include <sys/cdefs.h>
 
-__KERNEL_RCSID(0, "$NetBSD: mips_fpu.c,v 1.1.2.3 2010/05/15 20:13:43 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: mips_fpu.c,v 1.1.2.5 2011/04/29 08:26:28 matt Exp $");
+
+#include "opt_multiprocessor.h"
 
 #include <sys/param.h>
@@ -40,13 +42,13 @@
 #endif
 #include <sys/lwp.h>
-#include <sys/user.h>
 
 #include <mips/locore.h>
 #include <mips/regnum.h>
-#ifdef DIAGNOSTIC
-#include <mips/cpu.h>
-#endif
-
-#ifndef NOFPU
+#include <mips/pcb.h>
+
+#ifndef NOFPU
+static void mips_fpu_state_save(lwp_t *, bool);
+static void mips_fpu_state_load(lwp_t *, bool);
+
 static struct {
 	kmutex_t fpx_mutex;
@@ -78,13 +80,8 @@
 fp_lock(void)
 {
-	struct lwp * const l = curlwp;
 	mutex_enter(&fp_mutex);
-
-	if ((l->l_flag & (LW_SINTR | LW_SYSTEM)) == 0) {
-		KASSERT((l->l_pflag & LP_BOUND) == 0);
-		l->l_pflag |= LP_BOUND;
-	}
-
-	return l->l_cpu;
+	kpreempt_disable();
+
+	return curcpu();
 }
 
@@ -92,16 +89,13 @@
 fp_unlock(void)
 {
-	struct lwp * const l = curlwp;
-	if ((l->l_flag & (LW_SINTR | LW_SYSTEM)) == 0) {
-		KASSERT(l->l_pflag & LP_BOUND);
-		l->l_pflag ^= LP_BOUND;
-	}
 	mutex_exit(&fp_mutex);
+	kpreempt_enable();
 }
 
 static void
-fpcpu_acquire(struct lwp *l)
+fpcpu_acquire(lwp_t *l)
 {
 	struct cpu_info * const ci = curcpu();
+	KASSERT(kpreempt_disabled());
 	KASSERT(mutex_owned(&fp_mutex));
 	KASSERT(l == curlwp);
@@ -123,4 +117,5 @@
 fpcpu_release(struct cpu_info *ci)
 {
+	KASSERT(kpreempt_disabled());
 	KASSERT(mutex_owned(&fp_mutex));
 	KASSERT(ci->ci_data.cpu_idlelwp->l_fpcpu == NULL);
@@ -136,15 +131,158 @@
 #endif
 }
-
-static void
-fpusave(struct lwp *l)
-{
+#endif /* !NOFPU */
+
+void
+fpu_discard(void)
+{
+#ifndef NOFPU
+	lwp_t * const l = curlwp;
+	if (l->l_fpcpu != NULL) {
+		fp_lock();
+		if (__predict_true(l->l_fpcpu != NULL)) {
+			KASSERT(l->l_fpcpu->ci_fpcurlwp == l);
+			l->l_md.md_utf->tf_regs[_R_SR] &= ~MIPS_SR_COP_1_BIT;
+			fpcpu_release(l->l_fpcpu);
+		}
+		fp_unlock();
+	}
+#endif
+}
+
+void
+fpu_load(void)
+{
+#ifndef NOFPU
+	lwp_t * const l = curlwp;
 	struct trapframe * const tf = l->l_md.md_utf;
-	mips_fpreg_t * const fp = l->l_addr->u_pcb.pcb_fpregs.r_regs;
+	struct cpu_info *ci;
+
+	KASSERT(l == curlwp);
+
+	ci = fp_lock();
+
+	/*
+	 * Does this CPU already have our FPU state loaded?
+	 */
+	if (l->l_fpcpu == ci) {
+		KASSERT(ci->ci_fpcurlwp == l);
+		tf->tf_regs[_R_SR] |= MIPS_SR_COP_1_BIT;
+		fp_unlock();
+		return;
+	}
+#ifdef MULTIPROCESSOR
+	/*
+	 * While another CPU has our FPU state, keep asking for it to free it.
+	 */
+	if (l->l_cpu != NULL) {
+		kpreempt_enable();
+		while (l->l_fpcpu != NULL) {
+			cpu_send_ipi(l->l_fpcpu, IPI_FPSAVE);
+			cv_wait(&fp_cv, &fp_mutex);
+		}
+		kpreempt_disable();
+		ci = curcpu();
+	}
+#endif /* MULTIPROCESSOR */
+	KASSERT(ci->ci_fpcurlwp != l);
+
+	/*
+	 * Save the current FPU state, if any.
+	 */
+	if (ci->ci_fpcurlwp->l_fpcpu == ci) {
+		mips_fpu_state_save(ci->ci_fpcurlwp, true);
+	}
+
+	/*
+	 * Now acquire this CPU's FPU for this lwp.
+	 */
+	fpcpu_acquire(l);
+
+	/*
+	 * Now load the FPU
+	 */
+	mips_fpu_state_load(l, fpu_used_p(l));
+
+	fp_unlock();
+#endif /* !NOFPU */
+}
+
+void
+fpu_save(void)
+{
+#ifndef NOFPU
+	fpu_save_lwp(curlwp);
+#endif
+}
+
+void
+fpu_save_lwp(lwp_t *l)
+{
+#ifndef NOFPU
+	if (!fpu_used_p(l) || l->l_fpcpu == NULL)
+		return;
+
+	struct cpu_info *ci = fp_lock();
+
+	/*
+	 * If the FPU state is on this CPU, save it to the PCB.  However
+	 * we leave the FPU attached to this LWP since this might just be
+	 * an inquiry.
+	 */
+	if (l->l_fpcpu == ci) {
+		KASSERT(ci->ci_fpcurlwp == l);
+		mips_fpu_state_save(l, false);
+		fp_unlock();
+		return;
+	}
+
+#ifdef MULTIPROCESSOR
+	/*
+	 * Our FP state is on another CPU so we need send it an IPI
+	 * to get it to save it.  That CPU will broadcast when it has
+	 * saved the FP state and released the FPU.
+	 */
+	kpreempt_enable();
+	while (l->l_fpcpu != NULL) {
+		cpu_send_ipi(l->l_fpcpu, IPI_FPSAVE);
+		cv_wait(&fp_cv, &fp_mutex);
+	}
+	kpreempt_disable();
+#endif /* MULTIPROCESSOR */
+
+	fp_unlock();
+#endif /* !NOFPU */
+}
+
+void
+fpusave_cpu(struct cpu_info *ci)
+{
+#ifndef NOFPU
+	fp_lock();
+
+	/*
+	 * If the current FPU is dirty, save it.
+	 */
+	if (ci->ci_fpcurlwp->l_fpcpu == ci) {
+		mips_fpu_state_save(ci->ci_fpcurlwp, true);
+
+		/*
+		 * Release the FPU
+		 */
+		fpcpu_release(ci);
+	}
+
+	fp_unlock();
+#endif /* !NOFPU */
+}
+
+#ifndef NOFPU
+void
+mips_fpu_state_save(lwp_t *l, bool release)
+{
+	struct trapframe * const tf = l->l_md.md_utf;
+	struct pcb * const pcb = lwp_getpcb(l);
+	mips_fpreg_t * const fp = pcb->pcb_fpregs.r_regs;
 	uint32_t status, fpcsr;
-
-#ifdef LOCKDEBUG
-	KASSERT(mutex_locked(&fp_mutex));
-#endif
 
 	/*
@@ -154,10 +292,5 @@
 		return;
 
-	/*
-	 * this thread yielded the FPA.
-	 */
-	KASSERT(l->l_fpcpu == curcpu());
-	KASSERT(l->l_fpcpu->ci_fpcurlwp == l);
-	KASSERT(tf->tf_regs[_R_SR] & MIPS_SR_COP_1_BIT);	/* it should be on */
+	l->l_cpu->ci_ev_fpu_saves.ev_count++;
 
 	/*
@@ -174,5 +307,5 @@
 		"cfc1	%1, $31"	"\n\t"
 		".set reorder"		"\n\t"
-		".set at" 
+		".set at"
 	    :	"=&r" (status), "=r"(fpcsr)
 	    :	"r"(tf->tf_regs[_R_SR] & (MIPS_SR_COP_1_BIT|MIPS3_SR_FR|MIPS_SR_KX|MIPS_SR_INT_IE)),
@@ -182,5 +315,7 @@
 	 * Make sure we don't reenable FP when we return to userspace.
 	 */
-	tf->tf_regs[_R_SR] ^= MIPS_SR_COP_1_BIT;
+	if (release) {
+		tf->tf_regs[_R_SR] ^= MIPS_SR_COP_1_BIT;
+	}
 
 	/*
@@ -272,47 +407,22 @@
 	__asm volatile ("mtc0 %0, $%1" :: "r"(status), "n"(MIPS_COP_0_STATUS));
 }
-#endif /* !NOFPU */
-
-void
-fpuload_lwp(struct lwp *l)
-{
-#ifndef NOFPU
+
+void
+mips_fpu_state_load(lwp_t *l, bool used)
+{
 	struct trapframe * const tf = l->l_md.md_utf;
-	mips_fpreg_t * const fp = l->l_addr->u_pcb.pcb_fpregs.r_regs;
+	struct pcb * const pcb = lwp_getpcb(l);
+	mips_fpreg_t * const fp = pcb->pcb_fpregs.r_regs;
 	uint32_t status;
 	uint32_t fpcsr;
 
-	KASSERT(l == curlwp);
-
-	struct cpu_info * const ci = fp_lock();
-	/*
-	 * Does this CPU already have our FPU state loaded?
-	 */
-	if (l->l_fpcpu == ci) {
-		KASSERT(ci->ci_fpcurlwp == l);
-		tf->tf_regs[_R_SR] |= MIPS_SR_COP_1_BIT;
-		fp_unlock();
-		return;
-	}
-#ifdef MULTIPROCESSOR
-	/*
-	 * While another CPU has our FPU state, keep asking for it to free it.
-	 */
-	while (l->l_fpcpu != NULL) {
-		cpu_send_ipi(l->l_fpcpu, IPI_FPSAVE);
-		cv_wait(&fp_cv, &fp_mutex);
-	}
-#endif /* MULTIPROCESSOR */
-	KASSERT(ci->ci_fpcurlwp != l);
-	/*
-	 * Save the current FPU state, if any.
-	 */
-	if (ci->ci_fpcurlwp->l_fpcpu == ci)
-		fpusave(ci->ci_fpcurlwp);
-
-	/*
-	 * Now acquire this CPU's FPU for this lwp.
-	 */
-	fpcpu_acquire(l);
+	l->l_cpu->ci_ev_fpu_loads.ev_count++;
+
+	/*
+	 * If this is the first time the state is being loaded, zero it first.
+	 */
+	if (__predict_false(!used)) {
+		memset(&pcb->pcb_fpregs, 0, sizeof(pcb->pcb_fpregs));
+	}
 
 	/*
@@ -433,81 +543,4 @@
 	    ::	"r"(fpcsr &~ MIPS_FPU_EXCEPTION_BITS), "r"(status),
 		"n"(MIPS_COP_0_STATUS));
-
-	fp_unlock();
-#endif /* !NOFPU */
-}
-
-void
-fpudiscard_lwp(struct lwp *l)
-{
-#ifndef NOFPU
-	if (l->l_fpcpu != NULL) {
-		fp_lock();
-		KASSERT(l->l_fpcpu->ci_fpcurlwp == l);
-		l->l_md.md_utf->tf_regs[_R_SR] &= ~MIPS_SR_COP_1_BIT;
-		fpcpu_release(l->l_fpcpu);
-		fp_unlock();
-	}
-#endif
-}
-
-void
-fpusave_lwp(struct lwp *l)
-{
-#ifndef NOFPU
-	struct cpu_info *ci;
-
-	if (l->l_fpcpu == NULL)
-		return;
-
-	ci = fp_lock();
-
-	/*
-	 * If the FPU state is on this CPU, save it to the PCB.  However
-	 * we leave the FPU attached to this LWP since this might just be
-	 * an inquiry.
-	 */
-	if (l->l_fpcpu == ci) {
-		KASSERT(ci->ci_fpcurlwp == l);
-		fpusave(l);
-		fp_unlock();
-		return;
-	}
-
-#ifdef MULTIPROCESSOR
-	/*
-	 * Our FP state is on another CPU so we need send it an IPI
-	 * to get it to save it.  That CPU will broadcast when it has
-	 * saved the FP state and released the FPU.
-	 */
-	do {
-		cpu_send_ipi(l->l_fpcpu, IPI_FPSAVE);
-		cv_wait(&fp_cv, &fp_mutex);
-	} while (l->l_fpcpu != NULL);
-#endif /* MULTIPROCESSOR */
-
-	fp_unlock();
-#endif /* !NOFPU */
-}
-
-void
-fpusave_cpu(struct cpu_info *ci)
-{
-#ifndef NOFPU
-	fp_lock();
-
-	/*
-	 * If the current FPU is dirty, save it.
-	 */
-	if (ci->ci_fpcurlwp->l_fpcpu == ci) {
-		fpusave(ci->ci_fpcurlwp);
-
-		/*
-		 * Release the FPU
-		 */
-		fpcpu_release(ci);
-	}
-
-	fp_unlock();
-#endif /* !NOFPU */
-}
+}
+#endif /* !NOFPU */
Index: /trunk/src/sys/arch/mips/mips/mips_fputrap.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips_fputrap.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips_fputrap.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: mips_fputrap.c,v 1.5.66.5 2010/02/23 20:33:48 matt Exp $ */
+/* $NetBSD: mips_fputrap.c,v 1.5.66.7 2011/04/29 08:26:29 matt Exp $ */
 
 /*
@@ -38,12 +38,17 @@
 
 #if defined(FPEMUL) || !defined(NOFPU)
-void mips_fpuexcept(struct lwp *, unsigned int);
-void mips_fpuillinst(struct lwp *, unsigned int, unsigned long);
-static int fpustat2sicode(unsigned int);
+void mips_fpuexcept(struct lwp *, uint32_t);
+void mips_fpuillinst(struct lwp *, uint32_t);
+static int fpustat2sicode(uint32_t);
 
 void
-mips_fpuexcept(struct lwp *l, unsigned int fpustat)
+mips_fpuexcept(struct lwp *l, uint32_t fpustat)
 {
 	ksiginfo_t ksi;
+
+#ifdef FPEMUL_DEBUG
+	printf("%s(%x,%#"PRIxREGISTER")\n",
+	   __func__, fpustat, l->l_md.md_utf->tf_regs[_R_PC]);
+#endif
 
 	KSI_INIT_TRAP(&ksi);
@@ -55,7 +60,12 @@
 
 void
-mips_fpuillinst(struct lwp *l, unsigned int opcode, unsigned long vaddr)
+mips_fpuillinst(struct lwp *l, uint32_t opcode)
 {
 	ksiginfo_t ksi;
+
+#ifdef FPEMUL_DEBUG
+	printf("%s(%x,%#"PRIxREGISTER")\n",
+	   __func__, opcode, l->l_md.md_utf->tf_regs[_R_PC]);
+#endif
 
 	KSI_INIT_TRAP(&ksi);
@@ -63,9 +73,9 @@
 	ksi.ksi_code = ILL_ILLOPC;
 	ksi.ksi_trap = opcode;
-	ksi.ksi_addr = (void *)vaddr;
+	ksi.ksi_addr = (void *)(uintptr_t)l->l_md.md_utf->tf_regs[_R_PC];
 	(*l->l_proc->p_emul->e_trapsignal)(l, &ksi);
 }
 
-static struct {
+static const struct {
 	unsigned int bit;
 	int code;
@@ -80,31 +90,12 @@
 
 static int
-fpustat2sicode(unsigned int fpustat)
+fpustat2sicode(uint32_t fpustat)
 {
-	int i;
+	for (size_t i = 0; i < __arraycount(fpecodes); i++) {
+		if (fpustat & fpecodes[i].bit)
+			return fpecodes[i].code;
+	}
 
-	for (i = 0; i < 6; i++)
-		if (fpustat & fpecodes[i].bit)
-			return (fpecodes[i].code);
-	return (FPE_FLTINV);
+	return FPE_FLTINV;
 }
 #endif /* FPEMUL || !NOFPU */
-
-void fpemul_trapsignal(struct lwp *, unsigned int, unsigned int);
-
-void
-fpemul_trapsignal(struct lwp *l, unsigned int sig, unsigned int code)
-{
-	ksiginfo_t ksi;
-
-#if DEBUG
-	printf("fpemul_trapsignal(%x,%x,%#"PRIxREGISTER")\n",
-	   sig, code, l->l_md.md_utf->tf_regs[_R_PC]);
-#endif
-
-	KSI_INIT_TRAP(&ksi);
-	ksi.ksi_signo = sig;
-	ksi.ksi_code = 1; /* XXX */
-	ksi.ksi_trap = code;
-	(*l->l_proc->p_emul->e_trapsignal)(l, &ksi);
-}
